[PATCH] Remove #include <linux/version.h>

From: Matthias Gehre <M.Gehre@gmx.de>

Included is a patch for the output of scripts/checkversion.pl:
checkversion find uses of LINUX_VERSION_CODE, KERNEL_VERSION, or
UTS_RELEASE without including <linux/version.h>, or cases of
including <linux/version.h> that don't need it.
The Patch was made against 2.6.15-git9.

Signed-off-by: Matthias Gehre <M.Gehre@gmx.de>
Signed-off-by: Alexey Dobriyan <adobriyan@gmail.com>

Index: linux-kj/arch/arm/plat-omap/clock.c
===================================================================
--- linux-kj.orig/arch/arm/plat-omap/clock.c	2006-01-18 02:21:12.000000000 +0300
+++ linux-kj/arch/arm/plat-omap/clock.c	2006-01-18 16:47:16.000000000 +0300
@@ -10,7 +10,6 @@
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation.
  */
-#include <linux/version.h>
 #include <linux/config.h>
 #include <linux/kernel.h>
 #include <linux/init.h>
Index: linux-kj/arch/arm26/nwfpe/fpmodule.c
===================================================================
--- linux-kj.orig/arch/arm26/nwfpe/fpmodule.c	2006-01-18 02:21:12.000000000 +0300
+++ linux-kj/arch/arm26/nwfpe/fpmodule.c	2006-01-18 16:47:16.000000000 +0300
@@ -24,7 +24,6 @@
 #include "fpa11.h"
 
 #include <linux/module.h>
-#include <linux/version.h>
 #include <linux/config.h>
 
 /* XXX */
Index: linux-kj/drivers/atm/adummy.c
===================================================================
--- linux-kj.orig/drivers/atm/adummy.c	2006-01-18 02:21:12.000000000 +0300
+++ linux-kj/drivers/atm/adummy.c	2006-01-18 16:47:16.000000000 +0300
@@ -4,7 +4,6 @@
 
 #include <linux/config.h>
 #include <linux/module.h>
-#include <linux/version.h>
 #include <linux/kernel.h>
 #include <linux/skbuff.h>
 #include <linux/pci.h>
Index: linux-kj/drivers/char/synclink_gt.c
===================================================================
--- linux-kj.orig/drivers/char/synclink_gt.c	2006-01-18 02:21:12.000000000 +0300
+++ linux-kj/drivers/char/synclink_gt.c	2006-01-18 16:47:16.000000000 +0300
@@ -48,7 +48,6 @@
 
 #include <linux/config.h>
 #include <linux/module.h>
-#include <linux/version.h>
 #include <linux/errno.h>
 #include <linux/signal.h>
 #include <linux/sched.h>
Index: linux-kj/drivers/net/gianfar_sysfs.c
===================================================================
--- linux-kj.orig/drivers/net/gianfar_sysfs.c	2006-01-18 02:21:12.000000000 +0300
+++ linux-kj/drivers/net/gianfar_sysfs.c	2006-01-18 16:47:16.000000000 +0300
@@ -35,7 +35,6 @@
 
 #include <asm/uaccess.h>
 #include <linux/module.h>
-#include <linux/version.h>
 
 #include "gianfar.h"
 
Index: linux-kj/drivers/net/ppp_mppe.c
===================================================================
--- linux-kj.orig/drivers/net/ppp_mppe.c	2006-01-18 02:21:12.000000000 +0300
+++ linux-kj/drivers/net/ppp_mppe.c	2006-01-18 16:47:16.000000000 +0300
@@ -46,7 +46,6 @@
 #include <linux/config.h>
 #include <linux/module.h>
 #include <linux/kernel.h>
-#include <linux/version.h>
 #include <linux/init.h>
 #include <linux/types.h>
 #include <linux/slab.h>
Index: linux-kj/drivers/net/sky2.c
===================================================================
--- linux-kj.orig/drivers/net/sky2.c	2006-01-18 02:21:12.000000000 +0300
+++ linux-kj/drivers/net/sky2.c	2006-01-18 16:47:16.000000000 +0300
@@ -32,7 +32,6 @@
 #include <linux/config.h>
 #include <linux/crc32.h>
 #include <linux/kernel.h>
-#include <linux/version.h>
 #include <linux/module.h>
 #include <linux/netdevice.h>
 #include <linux/dma-mapping.h>
Index: linux-kj/drivers/net/wireless/ipw2100.c
===================================================================
--- linux-kj.orig/drivers/net/wireless/ipw2100.c	2006-01-18 02:21:12.000000000 +0300
+++ linux-kj/drivers/net/wireless/ipw2100.c	2006-01-18 16:47:16.000000000 +0300
@@ -159,7 +159,6 @@ that only one external action is invoked
 #include <linux/stringify.h>
 #include <linux/tcp.h>
 #include <linux/types.h>
-#include <linux/version.h>
 #include <linux/time.h>
 #include <linux/firmware.h>
 #include <linux/acpi.h>
Index: linux-kj/drivers/net/wireless/ipw2200.c
===================================================================
--- linux-kj.orig/drivers/net/wireless/ipw2200.c	2006-01-18 02:21:12.000000000 +0300
+++ linux-kj/drivers/net/wireless/ipw2200.c	2006-01-18 16:47:16.000000000 +0300
@@ -31,7 +31,6 @@
 ******************************************************************************/
 
 #include "ipw2200.h"
-#include <linux/version.h>
 
 #define IPW2200_VERSION "git-1.0.8"
 #define DRV_DESCRIPTION	"Intel(R) PRO/Wireless 2200/2915 Network Driver"
Index: linux-kj/drivers/scsi/gdth_proc.c
===================================================================
--- linux-kj.orig/drivers/scsi/gdth_proc.c	2006-01-18 02:21:12.000000000 +0300
+++ linux-kj/drivers/scsi/gdth_proc.c	2006-01-18 16:47:16.000000000 +0300
@@ -3,6 +3,7 @@
  */
 
 #include <linux/completion.h>
+#include <linux/version.h>
 
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0)
 int gdth_proc_info(struct Scsi_Host *host, char *buffer,char **start,off_t offset,int length,   
Index: linux-kj/drivers/usb/atm/ueagle-atm.c
===================================================================
--- linux-kj.orig/drivers/usb/atm/ueagle-atm.c	2006-01-18 02:21:12.000000000 +0300
+++ linux-kj/drivers/usb/atm/ueagle-atm.c	2006-01-18 16:47:16.000000000 +0300
@@ -62,7 +62,6 @@
 #include <linux/firmware.h>
 #include <linux/ctype.h>
 #include <linux/kthread.h>
-#include <linux/version.h>
 #include <asm/unaligned.h>
 
 #include "usbatm.h"
Index: linux-kj/fs/9p/vfs_file.c
===================================================================
--- linux-kj.orig/fs/9p/vfs_file.c	2006-01-18 02:21:12.000000000 +0300
+++ linux-kj/fs/9p/vfs_file.c	2006-01-18 16:47:16.000000000 +0300
@@ -32,7 +32,6 @@
 #include <linux/string.h>
 #include <linux/smp_lock.h>
 #include <linux/inet.h>
-#include <linux/version.h>
 #include <linux/list.h>
 #include <asm/uaccess.h>
 #include <linux/idr.h>
Index: linux-kj/sound/mips/au1x00.c
===================================================================
--- linux-kj.orig/sound/mips/au1x00.c	2006-01-18 02:21:12.000000000 +0300
+++ linux-kj/sound/mips/au1x00.c	2006-01-18 16:47:16.000000000 +0300
@@ -39,7 +39,6 @@
 #include <sound/driver.h>
 #include <linux/init.h>
 #include <linux/slab.h>
-#include <linux/version.h>
 #include <sound/core.h>
 #include <sound/initval.h>
 #include <sound/pcm.h>